// #autoload
// #name = UT2K3KillSounds
// #version = 0.1
// #date = Jan 24, 2003
// #author = ilys
// #warrior = ilys
// #description = Plays a different sound when you kill someone for how many kills you have made within a certain space of time.
// #status = beta
// #category = ilys' Scripts
// #credits = megakid
// #include = support/callback.cs
// #include = support/kill_callbacks.cs
// #include = support/player_support.cs
// #include = support/team_tracker.cs

$UT2K3KillSounds::Enabled = 1;
$totalUT2K3KillSoundskills = 0;

if(!isFile("prefs/UT2K3KillSoundsPrefs.cs"))
	export("$UT2K3KillSounds::*", "prefs/UT2K3KillSoundsPrefs.cs", false);
exec("prefs/UT2K3KillSoundsPrefs.cs");

function UT2K3Killcheckkillcallback(%msgtype, %killerRef, %victimRef, %weapon, %i_die, %i_win, %suicide, %tk)
{
	%MySelf = PlayerList.getMyName();
	%killer = %killerRef.name;
	%victim = %victimRef.name;
	%type = detag(%msgtype);
	%myteamId = PlayerList.getTeamByName(%MySelf);
	%victimteamId = PlayerList.getTeamByName(%victim);
	%killerteamId = PlayerList.getTeamByName(%killer);
	if($UT2K3KillSounds::Enabled)
	{
		if(%i_win && !%i_die && !%tk)
		{
			$totalUT2K3KillSoundskills++;
			switch ($totalUT2K3KillSoundskills)
			{
				case 2:
					alxPlay(alxCreateSource(AudioChat, "doublekill.WAV"));
				case 3:
					alxPlay(alxCreateSource(AudioChat, "multikill.WAV"));
				case 4:
					alxPlay(alxCreateSource(AudioChat, "ultrakill.WAV"));
				case 5:
					alxPlay(alxCreateSource(AudioChat, "megakill.wav"));
				case 6:
					alxPlay(alxCreateSource(AudioChat, "monsterkill.wav"));
				case 7:
					alxPlay(alxCreateSource(AudioChat, "LudicrousKill.wav"));
			}
			if ($totalUT2K3KillSoundskills > 7)
			{
				alxPlay(alxCreateSource(AudioChat, "HolyShit.wav"));
			}	
			UT2K3KillSoundsCountSchedule();
		}
	}
}

function UT2K3KillSoundsCountSchedule()
{
	if(isEventPending(count.schedule))
		cancel(count.schedule);

	count.schedule = schedule(10000, 0, UT2K3KillSoundsCountReset, true);
}
	
function UT2K3KillSoundsCountReset() 
{
	$totalUT2K3KillSoundskills = 0;	
}

function UT2K3KillSoundsToggle(%val)
{
	if(%val) return;
	
	$UT2K3KillSounds::Enabled=!$UT2K3KillSounds::Enabled;
	if ($UT2K3KillSounds::Enabled)
	{
		addMessageHudLine("\c7UT2K3 Kill Sounds active.");
		$totalUT2K3KillSoundskills = 0;
		UT2K3KillSoundsSavePrefs();
	}
	else
	{
		addMessageHudLine("\c7UT2K3 Kill Sounds disabled.");
		$totalUT2K3KillSoundskills = 0;
		cancel($killtimerschedule);
		UT2K3KillSoundsSavePrefs();
	}
}

function UT2K3KillSoundsMatchStart(%msgType, %msgString)
{
	if(strstr(%msgString, "Match started!") != -1)
	{
		$totalUT2K3KillSoundskills = 0;
	}
}

function UT2K3KillSoundsClientJoin(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
{
	if(StrStr(%msgString, "Welcome to Tribes") != -1)
	{
		$totalUT2K3KillSoundskills = 0;
	}
}

function UT2K3KillSoundsSavePrefs()
{
	export("$UT2K3KillSounds::*", "prefs/UT2K3KillSoundsPrefs.cs", false);
}

package UT2K3KillSounds
{
function OptionsDlg::onWake(%this)
{
	if ($UT2K3KillSoundsBind $= "false")
	{
		$RemapName[$RemapCount]="Toggle UT2K3KillSounds";
		$RemapCmd[$RemapCount]="UT2K3KillSoundsToggle";
		$RemapCount++;
		$UT2K3KillSoundsBind = "true";
	}

	parent::onWake(%this);
}

function PlayGui::onWake(%this)
{
	callback.add(CallbackMsgClientJoin, "UT2K3KillSoundsClientJoin");
	callback.add(CallbackMsgMissionStart, "UT2K3KillSoundsMatchStart");
	callback.add(killcallback, "UT2K3Killcheckkillcallback");

	parent::onWake(%this);
}
};

activatePackage(UT2K3KillSounds);
